/************************/
/* N88-BASIC ASCII dump */
/************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXLNUM	10
#define	MAXLINE	10000


int main(int argc, char **argv)
{
	FILE	*infp,*outfp;
	int		c,i,j;
	int		add;
	int		lnkflag,lnk1,lnkptr;
	int		numflag,num1,linenum;
	int		remflag,strflag;
	int		flag;
	int		d1,d2,d;

	int		lineaddbuf[MAXLINE];
	int		linenumbuf[MAXLINE];
	int		linenumcnt;

	long int	gotonumptr[MAXLNUM];
	int		gotonumadd[MAXLNUM];
	int		gotonumcnt;

	unsigned char	command[0x80][16] = {

/*		0			1			2			3			*/

		"",			"END",		"FOR",		"NEXT",		/* 80 */
		"DATA",		"INPUT",	"DIM",		"READ",		/* 84 */
		"LET",		"GOTO",		"RUN",		"IF",		/* 88 */
		"RESTORE",	"GOSUB",	"RETURN",	"REM",		/* 8C */

		"STOP",		"PRINT",	"CLEAR",	"LIST",		/* 90 */
		"NEW",		"ON",		"WAIT",		"DEF",		/* 94 */
		"POKE",		"CONT",		"OUT",		"LPRINT",	/* 98 */
		"LLIST",	"CONSOLE",	"WIDTH",	"ELSE",		/* 9C */

		"TRON",		"TROFF",	"SWAP",		"ERASE",	/* A0 */
		"EDIT",		"ERROR",	"RESUME",	"DELETE",	/* A4 */
		"AUTO",		"RENUM",	"DEFSTR",	"DEFINT",	/* A8 */
		"DEFSNG",	"DELDBL",	"LINE",		"WHILE",	/* AC */

		"WEND",		"CALL",		"",			"",			/* B0 */
		"",			"WRITE",	"COMMON",	"CHAIN",	/* B4 */
		"OPTION",	"RANDOMIZE","DSKO$",	"OPEN",		/* B8 */
		"FIELD",	"GET",		"PUT",		"SET",		/* BC */

		"CLOSE",	"LOAD",		"MERGE",	"FILES",	/* C0 */
		"NAME",		"KILL",		"LSET",		"RSET",		/* C4 */
		"SAVE",		"LFILES",	"MON",		"COLOR",	/* C8 */
		"CIRCLE",	"COPY",		"CLS",		"PSET",		/* CC */

		"PRESET",	"PAINT",	"TERM",		"SCREEN",	/* D0 */
		"BLOAD",	"BSAVE",	"LOCATE",	"BEEP",		/* D4 */
		"ROLL",		"HELP",		"",			"KANJI",	/* D8 */
		"TO",		"THEN",		"TAB(",		"STEP",		/* DC */

		"USR",		"FN",		"SPC(",		"NOT",		/* E0 */
		"ERL",		"ERR",		"STRING$",	"USING",	/* E4 */
		"INSTR",	"'",		"VARPTR",	"ATTR$",	/* E8 */
		"DSKI$",	"SRQ",		"",			"INKEY$",	/* EC */

		">",		"=",		"<",		"+",		/* F0 */
		"-",		"*",		"/",		"^",		/* F4 */
		"AND",		"OR",		"XOR",		"EQV",		/* F8 */
		"IMP",		"MOD",		"\\",		""			/* FC */

	};


	unsigned char	command2[0x80][16] = {

/*		0			1			2			3			*/

		"",			"LEFT$",	"RIGHT$",	"MID$",		/* 80 */
		"SGN",		"INT",		"ABS",		"SQR",		/* 84 */
		"RND",		"SIN",		"LOG",		"EXP",		/* 88 */
		"COS",		"TAN",		"ATN",		"FRE",		/* 8C */

		"INP",		"POS",		"LEN",		"STR$",		/* 90 */
		"VAL",		"ASC",		"CHR$",		"PEEK",		/* 94 */
		"SPACE$",	"OCT$",		"HEX$",		"LPOS",		/* 98 */
		"CINT",		"CSNG",		"CDBL",		"FIX",		/* 9C */

		"CVI",		"CVS",		"CVD",		"EOF",		/* A0 */
		"LOC",		"LOF",		"FPOS",		"MKI$",		/* A4 */
		"MKS$",		"MKD$",		"",			"",			/* A8 */
		"",			"",			"",			"",			/* AC */

		"",			"",			"",			"",			/* B0 */
		"",			"",			"",			"",			/* B4 */
		"",			"",			"",			"",			/* B8 */
		"",			"",			"",			"",			/* BC */

		"",			"",			"",			"",			/* C0 */
		"",			"",			"",			"",			/* C4 */
		"",			"",			"",			"",			/* C8 */
		"",			"",			"",			"",			/* CC */

		"DSKF",		"VIEW",		"WINDOW",	"POINT",	/* D0 */
		"CSRLIN",	"MAP",		"SEARCH",	"MOTOR",	/* D4 */
		"PEN",		"DATE$",	"COM",		"KEY",		/* D8 */
		"TIME$",	"WBYTE",	"RBYTE",	"POLL",		/* DC */

		"ISET",		"IEEE",		"IRESET",	"STATUS",	/* E0 */
		"CMD",		"",			"",			"",			/* E4 */
		"",			"",			"",			"",			/* E8 */
		"",			"",			"",			"",			/* EC */

		"",			"",			"",			"",			/* F0 */
		"",			"",			"",			"",			/* F4 */
		"",			"",			"",			"",			/* F8 */
		"",			"",			"",			""			/* FC */

	};

	if (argc != 3) {
		fprintf(stderr, "Usage: n88toascii infile outfile\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "w")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	gotonumcnt = 0;
	linenumcnt = 0;

	add = 0x0001;
	lnkflag = 1;
	numflag = 0;
	remflag = 0;
	strflag = 0;
	while ((c = fgetc(infp)) != EOF) {
		add ++;

		if (lnkflag == 1) {
			lnkflag = 2;
			lnk1 = c;
			continue;
		}

		if (lnkflag == 2) {
			lnkflag = 0;
			numflag = 1;
			lnkptr = lnk1 + c*0x100;
			lineaddbuf[linenumcnt] = add-2;
			if (lnkptr == 0x0000) {
			break;
			}
			continue;
		}

		if (numflag == 1) {
			numflag = 2;
			num1 = c;
			continue;
		}

		if (numflag == 2) {
			numflag = 0;
			linenum = num1 + c*0x100;
			linenumbuf[linenumcnt] = linenum;
			linenumcnt ++;
			fprintf(outfp,"%d ",linenum);
			continue;
		}

		if (c == 0x00) {
			remflag = 0;
			strflag = 0;
			if (add == lnkptr) {
				fprintf(outfp,"\n");
				lnkflag = 1;
			} else if (add < lnkptr) {
				;
			} else {
				printf("Link pointer Error!!\n");
				printf("ADD:%04x LINK:%04x\n",add,lnkptr);
				exit(1);
			}
			continue;
		}

		if (remflag == 1) {
			fprintf(outfp,"%c",c);
			continue;
		}

		if (strflag == 1) {
			fprintf(outfp,"%c",c);
			if (c == 0x22) {
				strflag = 0;
			}
			continue;
		}

		if (c == 0x0b) {
			fprintf(outfp,"&O");
			d1 = fgetc(infp); add ++;
			d2 = fgetc(infp); add ++;
			fprintf(outfp,"%O",d1+d2*0x100);
		} else if (c == 0x0c) {
			fprintf(outfp,"&H");
			d1 = fgetc(infp); add ++;
			d2 = fgetc(infp); add ++;
			fprintf(outfp,"%X",d1+d2*0x100);
		} else if (c == 0x0d) {
			if (gotonumcnt >= MAXLNUM) {
				printf("Line number buffer Overflow!!\n");
				printf("ADD:%04x CHR:%02x\n",add-1,c);
				exit(1);
			} 
			d1 = fgetc(infp); add ++;
			d2 = fgetc(infp); add ++;
			gotonumadd[gotonumcnt] = d1+d2*0x100;
			gotonumptr[gotonumcnt] = ftell(outfp);
			fprintf(outfp,"     ");
			gotonumcnt ++;
		} else if (c == 0x0e) {
			d1 = fgetc(infp); add ++;
			d2 = fgetc(infp); add ++;
			fprintf(outfp,"%d",d1+d2*0x100);
		} else if (c == 0x0f) {
			d1 = fgetc(infp); add ++;
			fprintf(outfp,"%d",d1);
		} else if (0x11 <= c && c <= 0x1a) {
			fprintf(outfp,"%d",c-0x11);
		} else if (c == 0x1c) {
			d1 = fgetc(infp); add ++;
			d2 = fgetc(infp); add ++;
			d = d1 + d2*0x100;
			if (d >= 0x8000) {
				d = d - 0x10000;
			}
			fprintf(outfp,"%d",d);
		} else if (c == 0x1d) {
			printf("Illigal float!!\n");
			printf("ADD:%04x CHR:%02x\n",add-1,c);
			exit(1);
		} else if (c == 0x1f) {
			printf("Illigal double!!\n");
			printf("ADD:%04x CHR:%02x\n",add-1,c);
			exit(1);
		} else if (0x20 <= c && c <= 0x7f) {

			if (c == 0x3a) {
				d1 = fgetc(infp); add ++;
				d2 = fgetc(infp); add ++;
				if (d1 == 0x8f && d2 == 0xe9) {		// '
					fprintf(outfp,"'");
					remflag = 1;
					continue;
				}
				if (d1 == 0x9f) {					// ELSE
					fprintf(outfp,"%s",command[d1-0x80]);
					fseek(infp,-1L,SEEK_CUR);
					add = add - 1;
					continue;
				}
				fseek(infp,-2L,SEEK_CUR);
				add = add - 2;
			}

			fprintf(outfp,"%c",c);
			if (c == 0x22) {
				strflag = 1;
			}
		} else if (c == 0xff) {
			d1 = fgetc(infp); add ++;
			fprintf(outfp,"%s",command2[d1-0x80]);
		} else if (c >= 0x80) {
			if (c == 0xaf) {
				d1 = fgetc(infp); add ++;			// WHILE
			}
			fprintf(outfp,"%s",command[c-0x80]);
			if (c == 0x8f || c == 0xe9 || c == 0x84) {
				remflag = 1;
			}
		} else {
			printf("Illigal character!!\n");
			printf("ADD:%04x CHR:%02x\n",add-1,c);
			exit(1);
		}

	}

	for (j = 0;j < gotonumcnt;j ++) {
		flag = 0;
		for (i = 0;i < linenumcnt;i ++) {
			if (lineaddbuf[i]-1 == gotonumadd[j]) {
				gotonumadd[j] = linenumbuf[i];
				flag = 1;
				break;
			}
		}
		if (flag == 0) {
			printf("Line address not found!!\n");
			printf("%04x",gotonumadd[j]);
			exit(1);
		}
	}

	for (i = 0;i < gotonumcnt;i ++) {
		fseek(outfp,gotonumptr[i],SEEK_SET);
		fprintf(outfp,"%5d",gotonumadd[i]);
	}


	fclose(infp);
	fclose(outfp);

	return(0);
}
